diff --git a/pc-bios/bios.bin b/pc-bios/bios.bin
deleted file mode 100644
index bdb48314dfb79c6db84846278a696da3cb68d4ff..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/pc-bios/bios.bin b/pc-bios/bios.bin
new file mode 120000
index 0000000..d376f4e
--- /dev/null
+++ b/pc-bios/bios.bin
@@ -0,0 +1 @@
+../../seabios/out/bios.bin
\ No newline at end of file
diff --git a/pc-bios/vgabios-qxl.bin b/pc-bios/vgabios-qxl.bin
deleted file mode 100644
index 3156c6e3f1a18f011014cd983bf57fe7c5a03e96..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/pc-bios/vgabios-qxl.bin b/pc-bios/vgabios-qxl.bin
new file mode 120000
index 0000000..332b7c1
--- /dev/null
+++ b/pc-bios/vgabios-qxl.bin
@@ -0,0 +1 @@
+../../vgabios/VGABIOS-lgpl-latest.qxl.bin