diff --git a/pc-bios/README b/pc-bios/README
index 05cf042..e4154ab 100644
--- a/pc-bios/README
+++ b/pc-bios/README
@@ -17,7 +17,7 @@
 - SLOF (Slimline Open Firmware) is a free IEEE 1275 Open Firmware
   implementation for certain IBM POWER hardware.  The sources are at
   https://github.com/aik/SLOF, and the image currently in qemu is
-  built from git tag qemu-slof-20150429.
+  built from git tag qemu-slof-20150813.
 
 - sgabios (the Serial Graphics Adapter option ROM) provides a means for
   legacy x86 software to communicate with an attached serial console as
diff --git a/pc-bios/slof.bin b/pc-bios/slof.bin
index 0398ac67bc8d07410fe2ccc9d62c376ef3cf87c3..701933f7dc7b20f6cfcbb538a95142d0a598ada8 100644
GIT binary patch
diff --git a/roms/SLOF b/roms/SLOF
index 7d766a3..811277a 160000
--- a/roms/SLOF
+++ b/roms/SLOF
@@ -1 +1 @@
-Subproject commit 7d766a3ac9b2474f6c7da0084d43590cbbf047bf
+Subproject commit 811277ac91f674a9273e2b529791e9b75350f3e8