diff --git a/pc-bios/README b/pc-bios/README
index 9f65ffa..5a8a931 100644
--- a/pc-bios/README
+++ b/pc-bios/README
@@ -17,7 +17,7 @@
 - SLOF (Slimline Open Firmware) is a free IEEE 1275 Open Firmware
   implementation for certain IBM POWER hardware.  The sources are at
   https://github.com/aik/SLOF, and the image currently in qemu is
-  built from git tag qemu-slof-20151103.
+  built from git tag qemu-slof-20160223.
 
 - sgabios (the Serial Graphics Adapter option ROM) provides a means for
   legacy x86 software to communicate with an attached serial console as
diff --git a/pc-bios/slof.bin b/pc-bios/slof.bin
index 90f30996f96a77918dd57aa6131323f97630fe6c..f2384939efd167dad1153ac744d0624ad8591cfa 100644
GIT binary patch
diff --git a/roms/SLOF b/roms/SLOF
index b4c9380..e3d0572 160000
--- a/roms/SLOF
+++ b/roms/SLOF
@@ -1 +1 @@
-Subproject commit b4c93802a5b2c72f096649c497ec9ff5708e4456
+Subproject commit e3d05727a074619fc12d0a67f05cf2c42c875cce